osgAnimation::Channel Class Referenceabstract

`#include <Channel>`

Inheritance diagram for osgAnimation::Channel:

## Public Member Functions

| Channel ()
| Channel (const Channel &channel)
virtual | ~Channel ()
virtual Channel * | clone () const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | update (double time, float weight, int priority)=0
virtual void | reset ()=0
virtual Target * | getTarget ()=0
virtual bool | setTarget (Target *)=0
const std::string & | getName () const
void | setName (const std::string &name)
virtual double | getStartTime () const =0
virtual double | getEndTime () const =0
const std::string & | getTargetName () const
void | setTargetName (const std::string &name)
virtual Sampler * | getSampler ()=0
virtual const Sampler * | getSampler () const =0
virtual bool | createKeyframeContainerFromTargetValue ()=0
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Attributes

std::string | _targetName
std::string | _name
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Constructor & Destructor Documentation

## Channel() [1/2]

osgAnimation::Channel::Channel | ( |  | ) |

Referenced by Channel(), clone(), osgAnimation::TemplateChannel< DoubleStepSampler >::clone(), isSameKindAs(), and osgAnimation::TemplateChannel< DoubleStepSampler >::TemplateChannel().

## Channel() [2/2]

osgAnimation::Channel::Channel | ( | const Channel & | channel | ) |

References Channel().

## ~Channel()

virtual osgAnimation::Channel::~Channel | ( |  | ) |

virtual

## Member Function Documentation

## className()

virtual const char * osgAnimation::Channel::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## clone()

virtual Channel * osgAnimation::Channel::clone | ( |  | ) | const

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

References Channel().

## createKeyframeContainerFromTargetValue()

virtual bool osgAnimation::Channel::createKeyframeContainerFromTargetValue | ( |  | ) |

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## getEndTime()

virtual double osgAnimation::Channel::getEndTime | ( |  | ) | const

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## getName()

const std::string & osgAnimation::Channel::getName | ( |  | ) | const

Referenced by osgAnimation::UpdateUniform< T >::link().

## getSampler() [1/2]

virtual const Sampler * osgAnimation::Channel::getSampler | ( |  | ) | const

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## getSampler() [2/2]

virtual Sampler * osgAnimation::Channel::getSampler | ( |  | ) |

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## getStartTime()

virtual double osgAnimation::Channel::getStartTime | ( |  | ) | const

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## getTarget()

virtual Target * osgAnimation::Channel::getTarget | ( |  | ) |

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## getTargetName()

const std::string & osgAnimation::Channel::getTargetName | ( |  | ) | const

## isSameKindAs()

virtual bool osgAnimation::Channel::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

References Channel(), NULL, and osg::Object::Object().

## libraryName()

virtual const char * osgAnimation::Channel::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## reset()

virtual void osgAnimation::Channel::reset | ( |  | ) |

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## setName()

void osgAnimation::Channel::setName | ( | const std::string & | name | ) |

virtual

Set the name of object using C++ style string.

Reimplemented from osg::Object.

## setTarget()

virtual bool osgAnimation::Channel::setTarget | ( | Target * |  | ) |

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

Referenced by osgAnimation::UpdateUniform< T >::link().

## setTargetName()

void osgAnimation::Channel::setTargetName | ( | const std::string & | name | ) |

## update()

virtual void osgAnimation::Channel::update | ( | double | time,
|  | float | weight,
|  | int | priority )

pure virtual

Implemented in osgAnimation::TemplateChannel< SamplerType >, osgAnimation::TemplateChannel< DoubleCubicBezierSampler >, osgAnimation::TemplateChannel< DoubleLinearSampler >, osgAnimation::TemplateChannel< DoubleStepSampler >, osgAnimation::TemplateChannel< FloatCubicBezierSampler >, osgAnimation::TemplateChannel< FloatLinearSampler >, osgAnimation::TemplateChannel< FloatStepSampler >, osgAnimation::TemplateChannel< MatrixLinearSampler >, osgAnimation::TemplateChannel< QuatSphericalLinearSampler >, osgAnimation::TemplateChannel< QuatStepSampler >, osgAnimation::TemplateChannel< Vec2CubicBezierSampler >, osgAnimation::TemplateChannel< Vec2LinearSampler >, osgAnimation::TemplateChannel< Vec2StepSampler >, osgAnimation::TemplateChannel< Vec3CubicBezierSampler >, osgAnimation::TemplateChannel< Vec3LinearSampler >, osgAnimation::TemplateChannel< Vec3StepSampler >, osgAnimation::TemplateChannel< Vec4CubicBezierSampler >, osgAnimation::TemplateChannel< Vec4LinearSampler >, and osgAnimation::TemplateChannel< Vec4StepSampler >.

## Member Data Documentation

## _name

std::string osgAnimation::Channel::_name

protected

## _targetName

std::string osgAnimation::Channel::_targetName

protected

The documentation for this class was generated from the following file:

- Channel